"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.extractMachines = void 0;
// @ts-ignore
var helper_split_export_declaration_1 = __importDefault(require("@babel/helper-split-export-declaration"));
var path_1 = __importDefault(require("path"));
var babel_plugin_macros_1 = require("babel-plugin-macros");
var rollup_1 = require("rollup");
var plugin_babel_1 = __importDefault(require("@rollup/plugin-babel"));
var plugin_node_resolve_1 = __importDefault(require("@rollup/plugin-node-resolve"));
var module_1 = __importDefault(require("module"));
var generateRandomId = function () {
    return Math.random()
        .toString(36)
        .substring(2);
};
var generateUniqueId = function (map) {
    var id = generateRandomId();
    return Object.prototype.hasOwnProperty.call(map, id)
        ? generateUniqueId(map)
        : id;
};
var compiledOutputs = Object.create(null);
module_1["default"]._extensions['.xstate.js'] = function (module, filename) {
    var _a = filename.match(/-(\w+)\.xstate\.js$/), _match = _a[0], id = _a[1];
    module._compile(compiledOutputs[id], filename);
};
var cwd = process.cwd();
var extensions = ['.tsx', '.ts', '.jsx', '.js'];
var getImports = function (_a, path) {
    var t = _a.types;
    return path.node.specifiers.map(function (specifier) {
        if (t.isImportNamespaceSpecifier(specifier)) {
            throw new Error('Using a namespace import for `@xstate/import` is not supported.');
        }
        return {
            localName: specifier.local.name,
            importedName: specifier.type === 'ImportDefaultSpecifier'
                ? 'default'
                : specifier.local.name
        };
    });
};
var getReferencePathsByImportName = function (scope, imports) {
    var shouldExit = false;
    var hasReferences = false;
    var referencePathsByImportName = imports.reduce(function (byName, _a) {
        var importedName = _a.importedName, localName = _a.localName;
        var binding = scope.getBinding(localName);
        if (!binding) {
            shouldExit = true;
            return byName;
        }
        byName[importedName] = binding.referencePaths;
        hasReferences = hasReferences || Boolean(byName[importedName].length);
        return byName;
    }, {});
    if (!hasReferences || shouldExit) {
        return;
    }
    return referencePathsByImportName;
};
var getMachineId = function (importName, _a, callExpression) {
    var t = _a.types;
    var typeParameters = callExpression.typeParameters;
    if (!typeParameters ||
        !typeParameters.params[2] ||
        !t.isTSLiteralType(typeParameters.params[2]) ||
        !t.isStringLiteral(typeParameters.params[2].literal)) {
        console.log('You must pass three type arguments to your machine.');
        console.log();
        console.log('For instance:');
        console.log("const machine = " + importName + "<Context, Event, 'aUniqueIdForYourMachine'>({})");
        console.log();
        throw new Error('You must pass three type arguments to your machine.');
    }
    return typeParameters.params[2].literal.value;
};
var insertExtractingExport = function (_a, statementPath, _b) {
    var t = _a.types;
    var importName = _b.importName, index = _b.index, machineId = _b.machineId, machineIdentifier = _b.machineIdentifier;
    statementPath.insertAfter(t.exportNamedDeclaration(t.variableDeclaration('var', [
        t.variableDeclarator(t.identifier("__xstate_" + importName + "_" + index), t.objectExpression([
            t.objectProperty(t.identifier('id'), t.stringLiteral(machineId)),
            t.objectProperty(t.identifier('machine'), t.identifier(machineIdentifier)),
        ])),
    ])));
};
var handleMachineFactoryCalls = function (importName, _a) {
    var references = _a.references, babel = _a.babel;
    if (!references[importName]) {
        return;
    }
    var t = babel.types;
    references[importName].forEach(function (referencePath, index) {
        var callExpressionPath = referencePath.parentPath;
        if (!t.isCallExpression(callExpressionPath.node)) {
            throw new Error("`" + importName + "` can only be called.");
        }
        var machineId = getMachineId(importName, babel, callExpressionPath.node);
        var callExpressionParentPath = callExpressionPath.parentPath;
        var callExpressionParentNode = callExpressionParentPath.node;
        switch (callExpressionParentNode.type) {
            case 'VariableDeclarator': {
                if (!t.isIdentifier(callExpressionParentNode.id)) {
                    throw new Error("Result of the `" + importName + "` call can only appear in the variable declaration.");
                }
                var statementPath = callExpressionParentPath.getStatementParent();
                if (!statementPath.parentPath.isProgram()) {
                    throw new Error("`" + importName + "` calls can only appear in top-level statements.");
                }
                insertExtractingExport(babel, statementPath, {
                    importName: importName,
                    index: index,
                    machineId: machineId,
                    machineIdentifier: callExpressionParentNode.id.name
                });
                break;
            }
            case 'ExportDefaultDeclaration': {
                helper_split_export_declaration_1["default"](callExpressionParentPath);
                insertExtractingExport(babel, callExpressionParentPath.getStatementParent(), {
                    importName: importName,
                    index: index,
                    machineId: machineId,
                    machineIdentifier: callExpressionParentPath.node.declarations[0].id.name
                });
                break;
            }
            default: {
                throw new Error("`" + importName + "` calls can only appear in the variable declaration or as a default export.");
            }
        }
    });
};
var macro = babel_plugin_macros_1.createMacro(function (params) {
    handleMachineFactoryCalls('createMachine', params);
    handleMachineFactoryCalls('Machine', params);
});
var getCreatedExports = function (importName, exportsObj) {
    var extracted = [];
    var counter = 0;
    while (true) {
        var currentCandidate = exportsObj["__xstate_" + importName + "_" + counter++];
        if (!currentCandidate) {
            return extracted;
        }
        extracted.push(currentCandidate);
    }
};
exports.extractMachines = function (filePath) { return __awaiter(void 0, void 0, void 0, function () {
    var resolvedFilePath, build, output, chunk, code, uniqueId, fakeFileName, module_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                resolvedFilePath = path_1["default"].resolve(cwd, filePath);
                return [4 /*yield*/, rollup_1.rollup({
                        input: resolvedFilePath,
                        external: function (id) { return !/^(\.|\/|\w:)/.test(id); },
                        plugins: [
                            plugin_node_resolve_1["default"]({
                                extensions: extensions
                            }),
                            plugin_babel_1["default"]({
                                babelHelpers: 'bundled',
                                extensions: extensions,
                                plugins: [
                                    '@babel/plugin-transform-typescript',
                                    '@babel/plugin-proposal-optional-chaining',
                                    function (babel) {
                                        return {
                                            name: 'xstate-codegen-machines-extractor',
                                            visitor: {
                                                ImportDeclaration: function (path, state) {
                                                    if (state.filename !== resolvedFilePath ||
                                                        path.node.source.value !== '@xstate/compiled') {
                                                        return;
                                                    }
                                                    var imports = getImports(babel, path);
                                                    var referencePathsByImportName = getReferencePathsByImportName(path.scope, imports);
                                                    if (!referencePathsByImportName) {
                                                        return;
                                                    }
                                                    /**
                                                     * Other plugins that run before babel-plugin-macros might use path.replace, where a path is
                                                     * put into its own replacement. Apparently babel does not update the scope after such
                                                     * an operation. As a remedy, the whole scope is traversed again with an empty "Identifier"
                                                     * visitor - this makes the problem go away.
                                                     *
                                                     * See: https://github.com/kentcdodds/import-all.macro/issues/7
                                                     */
                                                    state.file.scope.path.traverse({
                                                        Identifier: function () { }
                                                    });
                                                    macro({
                                                        path: path,
                                                        references: referencePathsByImportName,
                                                        state: state,
                                                        babel: babel,
                                                        // hack to make this call accepted by babel-plugin-macros
                                                        isBabelMacrosCall: true
                                                    });
                                                }
                                            }
                                        };
                                    },
                                ]
                            }),
                        ]
                    })];
            case 1:
                build = _a.sent();
                return [4 /*yield*/, build.generate({
                        format: 'cjs',
                        exports: 'named'
                    })];
            case 2:
                output = _a.sent();
                chunk = output.output[0];
                code = chunk.code;
                uniqueId = generateUniqueId(compiledOutputs);
                try {
                    compiledOutputs[uniqueId] = code;
                    fakeFileName = path_1["default"].join(path_1["default"].dirname(resolvedFilePath), path_1["default"]
                        .basename(resolvedFilePath)
                        .replace(/\./g, '-') + "-" + uniqueId + ".xstate.js");
                    module_2 = new module_1["default"](fakeFileName);
                    module_2.load(fakeFileName);
                    return [2 /*return*/, __spreadArrays(getCreatedExports('createMachine', module_2.exports), getCreatedExports('Machine', module_2.exports))];
                }
                finally {
                    delete compiledOutputs[uniqueId];
                }
                return [2 /*return*/];
        }
    });
}); };
