#!/usr/bin/env node
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var gaze_1 = __importDefault(require("gaze"));
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var minimist_1 = __importDefault(require("minimist"));
var introspectMachine_1 = require("./introspectMachine");
var extractMachines_1 = require("./extractMachines");
var printToFile_1 = require("./printToFile");
var _a = minimist_1["default"](process.argv.slice(2)), arrayArgs = _a._, objectArgs = __rest(_a, ["_"]);
var _b = process.argv, pattern = _b[2];
var flattenRecords = function (filesAsRecord) {
    if (Array.isArray(filesAsRecord)) {
        return filesAsRecord;
    }
    return Object.values(filesAsRecord).reduce(function (array, paths) { return array.concat(flattenRecords(paths)); }, []);
};
if (!pattern) {
    console.log('You must pass a glob, for instance "**/src/**.machine.ts"');
    process.exit(1);
}
var toRelative = function (filePath) { return path_1["default"].relative(process.cwd(), filePath); };
var typedSuffix = /\.typed\.(js|ts|tsx|jsx)$/;
var tsExtension = /\.(ts|tsx|js|jsx)$/;
var fileCache = {};
gaze_1["default"](pattern, {}, function (err, watcher) {
    return __awaiter(this, void 0, void 0, function () {
        var filesAsRecord, files, filteredFiles, addToCache;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (err) {
                        console.log(err);
                        process.exit(1);
                    }
                    filesAsRecord = watcher.watched();
                    files = flattenRecords(filesAsRecord);
                    filteredFiles = files.filter(function (filePath) {
                        return !typedSuffix.test(filePath) && tsExtension.test(filePath);
                    });
                    if (filteredFiles.length === 0) {
                        console.log('No files found from that glob');
                        process.exit(1);
                    }
                    printToFile_1.printJsFiles();
                    console.clear();
                    addToCache = function (filePath) { return __awaiter(_this, void 0, void 0, function () {
                        var code, machines, _a, machine, id;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    code = '';
                                    try {
                                        code = fs_1["default"].readFileSync(filePath, 'utf8');
                                    }
                                    catch (e) { }
                                    if (!code) {
                                        console.log("Could not read from path " + filePath);
                                        return [2 /*return*/];
                                    }
                                    if (!code.includes('@xstate/compiled')) {
                                        return [2 /*return*/];
                                    }
                                    return [4 /*yield*/, extractMachines_1.extractMachines(filePath)];
                                case 1:
                                    machines = _b.sent();
                                    if (machines.length === 0) {
                                        return [2 /*return*/];
                                    }
                                    _a = machines[0], machine = _a.machine, id = _a.id;
                                    fileCache[filePath] = __assign(__assign({}, introspectMachine_1.introspectMachine(machine)), { id: id });
                                    return [2 /*return*/];
                            }
                        });
                    }); };
                    return [4 /*yield*/, filteredFiles.reduce(function (promise, filePath) { return __awaiter(_this, void 0, void 0, function () {
                            var e_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, promise];
                                    case 1:
                                        _a.sent();
                                        _a.label = 2;
                                    case 2:
                                        _a.trys.push([2, 4, , 5]);
                                        console.log("Scanning File: ".cyan.bold + toRelative(filePath).gray);
                                        return [4 /*yield*/, addToCache(filePath)];
                                    case 3:
                                        _a.sent();
                                        return [3 /*break*/, 5];
                                    case 4:
                                        e_1 = _a.sent();
                                        console.log(e_1);
                                        if (objectArgs.once) {
                                            console.log('Could not complete due to errors'.red.bold);
                                            // @ts-ignore
                                            this.close();
                                            process.exit(1);
                                        }
                                        return [3 /*break*/, 5];
                                    case 5: return [2 /*return*/];
                                }
                            });
                        }); }, Promise.resolve())];
                case 1:
                    _a.sent();
                    printToFile_1.printToFile(fileCache, objectArgs.outDir);
                    if (objectArgs.once) {
                        console.log('Completed!'.green.bold);
                        // @ts-ignore
                        this.close();
                        process.exit(0);
                    }
                    // @ts-ignore
                    this.on('changed', function (filePath) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    console.log("File Changed: ".cyan.bold + toRelative(filePath).gray);
                                    return [4 /*yield*/, addToCache(filePath)];
                                case 1:
                                    _a.sent();
                                    printToFile_1.printToFile(fileCache, objectArgs.outDir);
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    // @ts-ignore
                    this.on('added', function (filePath) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    console.log("File Added: ".green.bold + toRelative(filePath).gray);
                                    return [4 /*yield*/, addToCache(filePath)];
                                case 1:
                                    _a.sent();
                                    printToFile_1.printToFile(fileCache, objectArgs.outDir);
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    // @ts-ignore
                    this.on('deleted', function (filePath) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            console.log("File Deleted: ".red.bold + toRelative(filePath).gray);
                            delete fileCache[filePath];
                            printToFile_1.printToFile(fileCache, objectArgs.outDir);
                            return [2 /*return*/];
                        });
                    }); });
                    console.log("Watching for file changes in: ".cyan.bold + pattern.gray);
                    return [2 /*return*/];
            }
        });
    });
});
